let apiKey = f24_scripts_data['apiKey'];
//console.log('chiave api :', apiKey);

window.addEventListener('load', () => {
//let apiKey = document.getElementById('fatt-24-API-key'); 
let apiBtn = document.getElementById("fatt-24-API-verification"); // id del pulsante di verifica
    apiBtn.addEventListener('click', function (f) {
        let xhr = new XMLHttpRequest();
        let source = f24_scripts_data['source'];
        let params = "apiKey=" + apiKey + "&source=" + source; // la passa
        let today = new Date();

        xhr.open("post","https://www.app.fattura24.com/api/v0.3/TestKey", true);
        xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded; charset=UTF-8");
        xhr.send(params);
        xhr.onload = function () {
        //console.log(this.responseText);
            let response = this.responseText.replace("&egrave;", ""); //devo togliere questa parte altrimenti da problemi con l'encoding xml
            console.log(response);
            
            let parser = new DOMParser(); // legge il risultato xml
            let xml = parser.parseFromString(response, "text/xml");
            let code = xml.getElementsByTagName('returnCode');
            //let description = xml.getElementsByTagName('description');
            let subscriptionType = '';

            if (apiKey !== '' && apiKey.length === 32) {
                let type = xml.getElementsByTagName('type'); // tipo di abbonamento
                let result = [...type];
                if (result.length > 0) {
                    subscriptionType = result[0].innerHTML;
                }
            }
            
            // scadenza abbonamento
            let expiryMessage = '';			
            let expire = xml.getElementsByTagName('expire'); // data di scadenza
            if (expire.length > 0) {
                let year = expire[0].childNodes[0].nodeValue.slice(6, 10);
                // tolgo 1 perché in Js il primo mese è zero
                let month = expire[0].childNodes[0].nodeValue.slice(3, 5) - 1;
                let day = expire[0].childNodes[0].nodeValue.slice(0, 2);
                let expireDate = new Date(year, month, day);
                let diff = expireDate.getTime() - today.getTime();
                let diffInDays = Math.ceil(diff / (1000 * 3600 * 24));
            
                let expired = diffInDays <= 0; // se la differenza è negativa l'abbonamento è già scaduto
                    
                if (diffInDays < 30 && !expired) {
                    expiryMessage = "<br/><span style='color: red;'>Mancano " +  diffInDays + " giorni alla scadenza!</span> <a href='https://www.fattura24.com/' target='_blank'> Rinnova ora </a>"; 
                } else if (expired) {
                    expiryMessage = "<br/><span style='color: red;'>Abbonamento scaduto da " +  Math.abs(diffInDays) + " giorni!</span> <a href='https://www.fattura24.com/' target='_blank'> Rinnova ora </a>"; 
                }  
            }
                    
            let totalCallInLast24Hour = xml.getElementsByTagName('totalCallInLast24Hour');
                                                    
            if (code[0].childNodes[0].nodeValue == 1) {
            /**
            * Qui gestisco gli errori se l'albero xml non è completo
            * in particolare se manca la data di scadenza. Il testo risultante sostituisce quello predefinito
            * grazie alla proprietà innerHtml
            */
                try {  
                    document.getElementById("fatt-24-api-message").innerHTML = "<span style='color: green; font-size: 120%;'>chiave API verificata! </span><br/>Scadenza abbonamento: "+ expire[0].childNodes[0].nodeValue 
                    + expiryMessage +
                    "<br/>Totale chiamate API nelle ultime 24 ore: " + totalCallInLast24Hour[0].childNodes[0].nodeValue; 
                }
                catch (err) {
                    if (expire.length === 0) {
                        document.getElementById("fatt-24-api-message").innerHTML = "<span style='color: red; font-size: 120%;'>Account di Test! </span></br>";// solo gli account di test sono senza scadenza
                    } else {
                        document.getElementById("fatt-24-api-message").innerHTML = "<span style='color: red; font-size: 120%;'>Errore generico, contatta assistenza@fattura24.com! </span></br>"
                    }    
                }
                        
            } else if (!apiKey) {
                document.getElementById("fatt-24-api-message").innerHTML = "<span style='color: red; font-size: 120%;'>chiave API non inserita! </span></br>"; 
                    
            } else {
                /**
                * Qui cerco di ottenere il tipo di abbonamento per includere un messaggio di errore specifico
                * se non lo trovo visualizzo il messaggio generico (Davide Iandoli 24.01.2020)
                */
                if (subscriptionType && subscriptionType < 5) { 
                    document.getElementById("fatt-24-api-message").innerHTML = "<span style='color: red; font-size: 120%;'>Per usare il servizio è necessario un abbonamento Business o Enterprise! </span></br>";
                } else {
                    document.getElementById("fatt-24-api-message").innerHTML = "<span style='color: red; font-size: 120%;'>API Key non valida! </span></br>";
                }     
            }
        }
    }); 
});    