<?php

namespace fattura24;

if (!defined('ABSPATH')) exit;

require_once FATT_24_CODE_ROOT . 'api/api_wrapper.php';

// lista sezionali in F24
function fatt_24_getSezionale($idTipoDocumento)
{
    global $f24_sezionali;
    $listaNomi = array();
    // questa variabile la uso se fallisce la chiamata API (esempio);
    $listaNomi['Predefinito'] = __('Default', 'fattura24');
    if ($idTipoDocumento === 'fatture') {
        $isFattura = fatt_24_get_invoice_doctype() == '1' || fatt_24_get_invoice_doctype() == FATT_24_DT_FATTURA;
        $idTipoDocumento = $isFattura ? 1 : 11;
        //$idTipoDocumento = get_option('fatt-24-inv-create') == FATT_24_DT_FATTURA ? 1 : 11;
    }
    
    if (is_array($f24_sezionali) && $f24_sezionali['code'] !== 200) {
        $message_displayed = $f24_sezionali['disp_message'];
        return $listaNomi;
    }
    $xml = simplexml_load_string(utf8_encode($f24_sezionali));
    if (is_object($xml)) {
        // se ottengo la lista dei sezionali non mi serve - Davide Iandoli 6.06.2022
        if (!empty($xml)) {
            unset($listaNomi['Predefinito']);
        }
        foreach ($xml->sezionale as $sezionale) {
            foreach ($sezionale->doc as $doc) {
                if ((int)$doc->id == $idTipoDocumento && (int)$doc->stato == 1) {
                    $listaNomi[(int)$sezionale->id] = (string)$sezionale->anteprima;
                } else if ((int)$doc->id == $idTipoDocumento && (int)$doc->stato == 2) {
                    $listaNomi[(int)$sezionale->id] = (string)$sezionale->anteprima . __(' (Default)', 'fattura24');
                }
                 // visualizza l'anteprima e non l'id per migliore esperienza d'uso
            }
        }
    }
    //else
    return $listaNomi;
}