<?php
/**
 * Questo file è parte del plugin WooCommerce v3.x di Fattura24
 * Autore: Fattura24.com <info@fattura24.com>
 *
 * Descrizione: gestisce la tab "Configurazione Tassa" della schermata di impostazioni
 */
namespace fattura24;

if (!defined('ABSPATH')) {
    exit;
}

if (is_admin())
{
    //@session_start();
}

/**
 * Lista codici natura aggiornati
 */
function fatt_24_getNaturaOptions()
{
    $html = __("<select name='tax_code' class='postform'>", 'fattura24');
    $html .= __("<option value='Scegli' > Choose an item... </option>", 'fattura24');
    $html .= __("<optgroup label='N1'>", 'fattura24');
    $html .= __("<option value='N1'> N1 - escluse ex art.15 </option>", 'fattura24');
    $html .= __("</optgroup>", 'fattura24');
    $html .= __("<optgroup label='N2'>", 'fattura24');
    $html .= __("<option value='N2' disabled> N2 - non soggette </option>", 'fattura24');
    $html .= __("<option value='N2.1'> N2.1 - non soggette ad IVA ai sensi degli artt. da 7 a 7-septies del DPR 633/72 </option>", 'fattura24');
    $html .= __("<option value='N2.2'> N2.2 - non soggette - altri casi </option>", 'fattura24');
    $html .= __("</optgroup>", 'fattura24');
    $html .= __("<optgroup label='N3'>", 'fattura24');
    $html .= __("<option value='N3' disabled> N3 - non imponibili </option>", 'fattura24');
    $html .= __("<option value='N3.1'> N3.1 - non imponibili - esportazioni </option>", 'fattura24');
    $html .= __("<option value='N3.2'> N3.2 - non imponibili  - cessioni intracomunitarie </option>", 'fattura24');
    $html .= __("<option value='N3.3'> N3.3 - non imponibili  - cessioni verso San Marino </option>", 'fattura24');
    $html .= __("<option value='N3.4'> N3.4 - non imponibili  - operazioni assimilate alle cessioni all'esportazione </option>", 'fattura24');
    $html .= __("<option value='N3.5'> N3.5 - non imponibili  - a seguito di dichiarazioni d'intento </option>", 'fattura24');
    $html .= __("<option value='N3.6'> N3.6 - non imponibili - altre operazioni che non concorrono alla formazione del plafond </option>", 'fattura24');
    $html .= __("</optgroup>", 'fattura24');
    $html .= __("<optgroup label='N4'>", 'fattura24');
    $html .= __("<option value='N4'> N4 - esenti </option>", 'fattura24');
    $html .= __("</optgroup>", 'fattura24');
    $html .= __("<optgroup label='N5'>", 'fattura24');
    $html .= __("<option value='N5'> N5 - regime del margine / Iva non esposta in fattura </option>", 'fattura24');
    $html .= __("</optgroup>", 'fattura24');
    $html .= __("<optgroup label='N6'>", 'fattura24');
    $html .= __("<option value='N6' disabled> N6 - inversione contabile </option>", 'fattura24');
    $html .= __("<option value='N6.1'> N6.1 - inversione contabile - cessione di rottami e altri materiali di recupero </option>", 'fattura24');
    $html .= __("<option value='N6.2'> N6.2 - inversione contabile - cessione di oro e argento puro </option>", 'fattura24');
    $html .= __("<option value='N6.3'> N6.3 - inversione contabile - subappalto nel settore edile </option>", 'fattura24');
    $html .= __("<option value='N6.4'> N6.4 - inversione contabile - cessione di fabbricati - cessione di fabbricati </option>", 'fattura24');
    $html .= __("<option value='N6.5'> N6.5 - inversione contabile - cessione di telefoni cellulari </option>", 'fattura24');
    $html .= __("<option value='N6.6'> N6.6 - inversione contabile - cessione di prodotti elettronici </option>", 'fattura24');
    $html .= __("<option value='N6.7'> N6.7 - inversione contabile - prestazioni comparto edile e settori connessi </option>", 'fattura24');
    $html .= __("<option value='N6.8'> N6.8 - inversione contabile - operazioni settore energetico </option>", 'fattura24');
    $html .= __("<option value='N6.9'> N6.9 - inversione contabile - altri casi </option>", 'fattura24');
    $html .= __("</optgroup>", 'fattura24');
    $html .= __("<optgroup label='N7'>", 'fattura24');
    $html .= __("<option value='N7'> N7 - IVA assolta in altro stato UE </option>", 'fattura24');
    $html .= __("</optgroup>", 'fattura24');
    $html .= __("</select>", 'fattura24');

    return $html;
}

// visualizza la schermata "Configurazione Tassa"
function fatt_24_show_tax()
{
    global $wpdb;
    $prefix = is_multisite()? $wpdb->base_prefix : $wpdb->prefix;
    $blog_id = is_multisite()? get_current_blog_id() : 1;
    $table_name = $prefix . "fattura_tax";
    $tax_id = ''; // definisco $tax_id
    $tax_rate = fatt_24_getZeroRates();
    $fattEl = fatt_24_get_invoice_doctype() == FATT_24_DT_FATTURA_ELETTRONICA;
    $msg = '';
    $type = '';
    /*if (!empty($tax_rate) && empty(fatt_24_getNatureColumn())) {
        $type = $invoiceOptionSelected == FATT_24_DT_FATTURA_ELETTRONICA ? 'error' : 'warning';
        $msg = fatt_24_NaturaMessage();
    }*/ 
 

    if (isset($_POST['insert'])) {
        $tax_id = sanitize_text_field($_POST["tax_id"]);
        $tax_code = sanitize_text_field($_POST["tax_code"]);
        $id = isset($_GET['id']) ? $_GET['id'] : ''; //mi serve per controllare le modifiche al post

        if (empty($tax_id)) {
            $type = 'error';
            $msg=__('Please select Tax Name', 'fattura24');
        } elseif ($tax_code == "Scegli") {
            $type = 'error';
            $msg=__('Please enter Natura', 'fattura24');
        } else {
			 /**
             * Se faccio click su 'Modifica' la variabile id NON è vuota, perciò posso aggiornare il record
             * passando per la condizione else; altrimenti mostro il messaggio di avvertimento
             * fix del 15.09.2020 - Davide Iandoli
             */
            $row = $wpdb->get_results($wpdb->prepare("SELECT * from $table_name  where tax_id=%s and blog_id=%s", $tax_id, $blog_id));
            if (count($row) > 0) {
                if (empty($id)) {
                    $type = 'warning';
                    $msg=__('Duplicate entry found with the same Tax', 'fattura24');
                } else {
                    $wpdb->update(
                        $table_name, //table
                        array('tax_id' => $tax_id, 'tax_code' => $tax_code, 'blog_id' => $blog_id), //data
                        array('id' => $id), //where
                        array('%s'), //data format
                        array('%s','%s') //where format
                    );
                   
                    wp_redirect('admin.php?page=fatt-24-tax');
                }
            } elseif (count($row) == 0) {
                $wpdb->insert(
                    $table_name, //table
                       array('tax_id' => $tax_id, 'tax_code' => $tax_code, 'blog_id' => $blog_id), //data
                       array('%d', '%s') //data format
                );
                
                wp_redirect('admin.php?page=fatt-24-tax');
                exit;
            }
        }
    } elseif (isset($_GET['del'])) {
        $id=sanitize_text_field($_GET['del']);
        $wpdb->query($wpdb->prepare("DELETE FROM $table_name WHERE id = %s AND blog_id = %s", $id, $blog_id));
        $type = 'success';
        $msg =__('Record has been deleted successfully', 'fattura24');
        wp_redirect('admin.php?page=fatt-24-tax');
        exit;
    } elseif (isset($_GET['id'])) {
        $id = $_GET['id'];
        $row = $wpdb->get_results($wpdb->prepare("SELECT * from $table_name  where id=%s AND blog_id = %s", $id, $blog_id));

        if (count($row) > 0) {
            $row = $row[0];
            $id = $row->id;
            $tax_code=$row->tax_code;
            $tax_id=$row->tax_id;
        }
    } ?>

	<div class='wrap'>
    <h2></h2>
    <?php fatt_24_get_link_and_logo(__('', 'fatt-24-tax')); 
        echo fatt_24_build_nav_bar();
    ?>

   
   
    <?php
        // controllo se ci sono altri messaggi già visualizzati
        $naturaMessages = fatt_24_getNaturaMessages();
        if (empty($naturaMessages) && !empty($msg)) {
            echo fatt_24_getMessageHtml($msg, $type, true);
        }
        ?>
            <form method='post' >
    		<table class='wp-list-table widefat fixed'>
                <tr>
                   <th class="ss-th-width" width="15%"><?php echo __('Tax', 'fattura24'); ?></th>
                    	<td>
						<?php
                         
                          $select = "<select name='tax_id' class='postform'>";
                          $select.= "<option value=''>".__('Select Tax', 'fattura24')."</option>";
                            if (!empty($tax_rate)) {
                                foreach ($tax_rate as $category) {
                                    if ($category->tax_rate_id==$tax_id) {
                                        $select.= "<option value='".$category->tax_rate_id."' selected='selected'>".$category->tax_rate_name."</option>";
                                    } else {
                                        $select.= "<option value='".$category->tax_rate_id."'>".$category->tax_rate_name."</option>";
                                    }
                                }
                            }
                                                
                            $select.= "</select>";
                            echo $select;
 

                        ?>
						</td>
                </tr>
                <tr>
                    <th class="ss-th-width"><?php _e('Natura', 'fattura24'); ?></th>
     				<td><?php echo fatt_24_getNaturaOptions(); ?></td>
                </tr>
				<tr>
                    <th class="ss-th-width"></th>
                    <td> <input type='submit' name="insert" value=<?php _e('Save', 'fattura24')?> class='button'></td>
                </tr>
            </table>
		</form>
	</div>

    <div class='wrap'>

        <?php
            //$prefix = is_multisite() ? $wpdb->base_prefix : $wpdb->prefix;
            // WooCommerce aggiunge tante tabelle per quanti sono i siti nel network
            $prefix = $wpdb->prefix;
            $sql="SELECT m.id,m.tax_id,m.tax_code,m.blog_id, t.tax_rate_name from $table_name as m LEFT JOIN ".$prefix."woocommerce_tax_rates as t ON (m.tax_id=t.tax_rate_id) order by m.id desc";
            $rows = $wpdb->get_results($sql); 
            $showCurrentBlogId = $blog_id == get_current_blog_id();
        ?>

        <table class='wp-list-table widefat fixed striped pages'>
			<thead>
            <tr>
                <th class="manage-column ss-list-width" width="80"><?php echo __('ID', 'fattura24'); ?></th>
                <th class="manage-column ss-list-width"><?php _e('Name', 'fattura24'); ?></th>
                <th class="manage-column ss-list-width"><?php _e('Natura', 'fattura24'); ?></th>
                <th colspan="2" width="150"><?php _e('Action', 'fattura24'); ?></th>
            </tr>
            </thead>
			<tbody>
				<?php foreach ($rows as $row) { 
                      // con questa booleana gestisco la tabella in modalità multisito
                      $showRow = $row->blog_id == get_current_blog_id(); ?>
           			<tr>
                        <?php if ($showRow) { ?>
               			<td class="manage-column ss-list-width"><?php echo $row->id; ?></td>
               			<td class="manage-column ss-list-width"><?php echo $row->tax_rate_name; ?></td>
               			<td class="manage-column ss-list-width"><?php echo $row->tax_code; ?></td>
               			<td><a href="<?php echo admin_url('admin.php?page=fatt-24-tax&id=' . $row->id); ?>"><?php echo __('Edit', 'fattura24'); ?></a></td>
		    			<td><a href="<?php echo admin_url('admin.php?page=fatt-24-tax&del=' . $row->id); ?>"><?php echo __('Delete', 'fattura24'); ?></a></td>
                        <?php } ?>
           			</tr>
       			<?php } ?>
   			</tbody>
        </table>
    </div>
	<div class="wrap">
       <div> 
        <table width="100%">         
           <tr>
                <td style="height: 440px; vertical-align: top;">
                    <p style="font-size:150%; font-weight:bold;"><?php _e('User instructions', 'fattura24') ?></p>
                  
                        <ol>
                            <li style ="font-size:120%;"><?php _e('Configure in Woocommerce->Settings->Tax one ore more zero rated taxes', 'fattura24')?></li>
                            <li style ="font-size:120%;"><?php _e('Warning: tax name should match the legal reference / natura.', 'fattura24')?></li>
                            <li style ="font-size:120%;"><?php _e('Save the changes: first dropdown will list all rates configured.', 'fattura24')?></li>
                            <li style ="font-size:120%;"><?php _e('Choose natura and save the changes.', 'fattura24')?></li>
                        </ol>
                      
                 
                    <p style = "padding:10px; font-size:120%;"><?php _e('Here below an explanatory picture.', 'fattura24')?></p>
                </td>
                <td style="width:250px; vertical-align: top;">
                    <?php echo fatt_24_infobox(); ?>
                </td> 
            </tr>
        </table>
        </div>        
    <div style="margin-top:-200px;"><?php echo fatt_24_img(fatt_24_attr('src', fatt_24_png('../assets/fattura24tax')), array())?></div>
           
	</div>
    <?php
}
