<?php
/**
 * Questo file è parte del plugin WooCommerce v3.x di Fattura24
 * Autore: Fattura24.com <info@fattura24.com>
 *
 * Descrizione: Tab "VideoGuides" della schermata di impostazioni
 *
 */

 namespace fattura24;

 if (!defined('ABSPATH')) {
     exit;
 }

function fatt_24_hide_notice_text()
{
    return get_locale() == 'it_IT';
}

function fatt_24_show_videos()
{
    ?>
     <div class='wrap'>
    <h2></h2>
    <?php fatt_24_get_link_and_logo(__('', 'fatt-24-videos'));

    echo fatt_24_build_nav_bar();

    $notice = '';
    if (!fatt_24_hide_notice_text()) {
        $notice = fatt_24_h1(__('Notice : these video guides are spoken in Italian', 'fattura24'));
    }

    echo $notice; 
    ?>
   

   <table width="100%">
        <tr style="vertical-align: top;">
            <td>
                <a href="https://youtu.be/svsJbyVNQmk" target="_blank">
                    <?php echo '<img src="' . fatt_24_jpg('../assets/lezione1-wp-wc') .'" width="350px" alt="lezione 1 WooCommerce" />'; ?>
                </a>    
            </td>
            <td><h2 style="padding-left: 10px;"><?php echo __('Lesson 1 - Plugin installation and first setup', 'fattura24') ?></h2>
                <p style="padding-left: 10px; font-size: 120%; text-align: justify;">
                    <?php echo __('In this lesson we will explain how to install and activate Fattura24 plugin for WooCommerce and we will setup a basic configuration', 'fattura24'); ?>
                </p>
            </td>
       
            <td rowspan="2" style="width: 20%;"><?= fatt_24_infobox(); ?></td>
        </tr>
        <tr style="vertical-align: top;">
            <td>
                <a href="https://youtu.be/iTDYvCVyG1Q" target="_blank">
                    <?php echo '<img src="' . fatt_24_jpg('../assets/lezione2-wp-wc') .'" width="350px" alt="lezione 2 WooCommerce" />'; ?>
                </a>    
            </td>
            <td><h2 style="padding-left: 10px;"><?php echo __('Lesson 2 - WooCommerce tax settings and Natura IVA settings', 'fattura24') ?></h2>
                <p style="padding-left: 10px; font-size: 120%; text-align: justify;"> 
                    <?php echo __('In this lesson we will explain: how to enable tax calculation in WooCommerce, how to add VAT rates in the \'Standard\' tax class, how to add a zero rate, how to assign a Natura IVA code in Fattura24->Tax configuration and issue proper Electronic Invoices ', 'fattura24'); ?>
                </p>
            </td>
        </tr>   
        <tr style="vertical-align: top;">
            <td>
                <a href="https://youtu.be/1UEjxzoWw2s" target="_blank">
                    <?php echo '<img src="' . fatt_24_jpg('../assets/lezione3-wp-wc') .'" width="350px" alt="lezione 3 WooCommerce" />'; ?>
                </a>    
            </td>
            <td><h2 style="padding-left: 10px;"><?php echo __('Lesson 3 - Order checkout, order status in WooCommerce and document creation in Fattura24', 'fattura24') ?></h2>
                <p style="padding: 10px; font-size: 120%; text-align: justify;">
                    <?php echo __('In this video we will emulate a customer purchase in our shop, focusing on some WooCommerce fields and on fields added by Fattura24. At last we will check the order status and the documents created in Fattura24', 'fattura24'); ?>
                </p>
            </td>        
        </tr>   
    </table>         
<?php
}
